%define anolis_release 2
Summary:  A python module for system storage configuration
Name: python-blivet
Url: https://storageapis.wordpress.com/projects/blivet
Version: 3.10.0

Release: %{anolis_release}%{?dist}
Epoch: 1
License: LGPL-2.1-or-later
%global realname blivet
%global realversion %{version}
Source0: https://github.com/storaged-project/%{realname}/releases/download/%{realname}-%{realversion}/%{realname}-%{realversion}.tar.gz
Source1: https://github.com/storaged-project/%{realname}/releases/download/%{realname}-%{realversion}/%{realname}-%{realversion}-tests.tar.gz

Patch0: 0001-remove-btrfs-plugin.patch

Patch1: 0002-Fix-skipping-btrfs-calls-when-libblockdev-btrfs-plugin-is-missing.patch
Patch2: 0003-XFS-resize-test-fix.patch
Patch3: 0004-Run-mkfs-xfs-with-force-option-by-default.patch
Patch4: 0007-Fix-checking-for-NVMe-plugin-availability.patch
Patch5: 0008-Align-sizes-up-for-growable-LVs.patch
Patch6: 0009-mod_pass_in_stratis_test.patch
Patch7: 0010-Fix_running_tests_in_FIPS_mode.patch
Patch8: 0011-Make-GPT-default-label-type-on-all-architectures.patch
Patch9: 0012-Add-sw_64-support.patch

# Versions of required components (done so we make sure the buildrequires
# match the requires versions of things).
%global partedver 3.2
%global pypartedver 3.10.4
%global utillinuxver 2.15.1
%global libblockdevver 3.0
%global libbytesizever 0.3
%global pyudevver 0.18

BuildArch: noarch

%description
The python-blivet package is a python module for examining and modifying
storage configuration.

%package doc
Summary:        Documentation files for %{name}
Requires:       python3-%{realname} = %{epoch}:%{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package -n %{realname}-data
Summary: Data for the %{realname} python module.

BuildRequires: make
BuildRequires: systemd

Conflicts: python-blivet < 1:2.0.0
Conflicts: python3-blivet < 1:2.0.0

%description -n %{realname}-data
The %{realname}-data package provides data files required by the %{realname}
python module.

%package -n python3-%{realname}
Summary: A python3 package for examining and modifying storage configuration.

%{?python_provide:%python_provide python3-%{realname}}

BuildRequires: gettext
BuildRequires: python3-devel
BuildRequires: python3-setuptools

%{?__python3:Requires: %{__python3}}
Requires: python3
Requires: python3-six
Requires: python3-pyudev >= %{pyudevver}
Requires: parted >= %{partedver}
Requires: python3-pyparted >= %{pypartedver}
Requires: libselinux-python3
Requires: python3-libmount
Requires: python3-blockdev >= %{libblockdevver}
Recommends: libblockdev-btrfs >= %{libblockdevver}
Recommends: libblockdev-crypto >= %{libblockdevver}
Recommends: libblockdev-dm >= %{libblockdevver}
Recommends: libblockdev-fs >= %{libblockdevver}
Recommends: libblockdev-loop >= %{libblockdevver}
Recommends: libblockdev-lvm >= %{libblockdevver}
Recommends: libblockdev-mdraid >= %{libblockdevver}
Recommends: libblockdev-mpath >= %{libblockdevver}
Recommends: libblockdev-nvme >= %{libblockdevver}
Recommends: libblockdev-swap >= %{libblockdevver}
Requires: python3-bytesize >= %{libbytesizever}
Requires: util-linux >= %{utillinuxver}
Requires: lsof
Requires: python3-gobject-base
Requires: systemd-udev
Requires: %{realname}-data = %{epoch}:%{version}-%{release}

Obsoletes: blivet-data < 1:2.0.0

Obsoletes: python2-blivet < 1:2.0.2-2
Obsoletes: python-blivet < 1:2.0.2-2

%description -n python3-%{realname}
The python3-%{realname} is a python3 package for examining and modifying storage
configuration.

%prep
%autosetup -n %{realname}-%{realversion} -N
%autosetup -n %{realname}-%{realversion} -b1 -p1

%build
make PYTHON=%{__python3}

%install
make PYTHON=%{__python3} DESTDIR=%{buildroot} install

%find_lang %{realname}

%files -n %{realname}-data -f %{realname}.lang
%{_sysconfdir}/dbus-1/system.d/*
%{_datadir}/dbus-1/system-services/*
%{_libexecdir}/*
%{_unitdir}/*

%files -n python3-%{realname}
%license COPYING
%{python3_sitelib}/*

%files doc
%doc README.md ChangeLog examples

%changelog
* Mon Mar 31 2025 fenghui <fenghui@nfschina.com> - 3.10.0-2
- arch: Support sw_64 arch

* Wed Mar 26 2025 Xiaoping Liu <lxp01404969@alibaba-inc.com> - 3.10.0-1
- update to 3.10.0 from 3.6.1
- Migrated to SPDX license
- Remove the patch because the changes already exist upstream
- Add patches to fix some bugs
  [Patches cherry-pick from c10s. Original changelog:
  - Make GPT default label type on all architectures. ( 3.10.0-13 )]

* Wed Mar 13 2024 Zhao Hang <wb-zh951434@alibaba-inc.com> - 3.6.1-3
- Rebuild with python3.11

* Wed Aug 30 2023 Wenlong Zhang <zhangwenlong@loongson.cn> - 3.6.1-2
- add loongarch64 support for python-blivet

* Fri Dec 30 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.6.1-1
- update to version 3.6.1

* Mon Nov 07 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.4.3-3
- Remove btrfs plugin
- Bump version to rebuild

* Thu Nov 03 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.4.3-2
- Add doc package

* Wed Apr 6 2022 gcdota930915 <taifu.gc@alibaba-inc.com> - 3.4.3-1
- Init from upstream version 3.4.3
- Remove mpath plugin 
- Remove python2 support
